package org.myapp.ejb;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.Topic;

import org.apache.log4j.Logger;

@MessageDriven(name = "TestMDB", activationConfig = {
		//@ActivationConfigProperty(propertyName = "maxSession", propertyValue = "30"),
		@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
		@ActivationConfigProperty(propertyName = "destination", propertyValue = "topic/AlchemyJobTopic"),
		@ActivationConfigProperty(propertyName = "subscriptionDurability", propertyValue = "Durable"),
		//@ActivationConfigProperty(propertyName = "subscriptionName", propertyValue="TestMDB"),
		@ActivationConfigProperty(propertyName = "clientID", propertyValue="Alchemy2"),
		@ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
		@ActivationConfigProperty(propertyName = "messageSelector", propertyValue = "MESSAGE_TYPE<>'SMSOptOut' AND MESSAGE_TYPE <>'BatchTrigger'")
		})
public class TestMDB implements MessageListener
{
	private final Logger log = Logger.getLogger(getClass());
	
	public static final String UPDATE_ACCOUNT = "UpdateAccount";
	
	@Resource(mappedName = "java:jboss/activemq/TopicConnectionFactory")
	private ConnectionFactory connectionFactory;
	
	@Resource(mappedName = "java:jboss/activemq/topic/outbound")
	private Topic topic;

	public TestMDB()
	{
	}
	
	@PostConstruct
	public void init()
	{
		
	}
	
	public void onMessage(Message msg)
	{
		if (log.isDebugEnabled())
			log.debug("Message received");
		
		try
		{
			Connection connection = connectionFactory.createConnection();
			Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
			MessageProducer producer = session.createProducer(topic);
		
			MapMessage mm = (MapMessage) msg;
			
			MapMessage nm = session.createMapMessage();
			
			nm.setString(UPDATE_ACCOUNT, mm.getString(UPDATE_ACCOUNT));
			if (log.isDebugEnabled())
				log.debug("Message : " + mm.getString(UPDATE_ACCOUNT));

			log.debug("Entered TestMDB Processing: "+ nm.getJMSMessageID());
			connection.start();
			producer.send(nm);
			session.close();
			connection.close();
		}
		catch (JMSException e)
		{
			log.debug("Message errored");
			e.printStackTrace();
		}
	}
}
